// OsobaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Rodokmen.h"
#include "OsobaDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COsobaDlg dialog


COsobaDlg::COsobaDlg(CArray<CString,CString> &h,int ja,int otec,int matka,CWnd* pParent /*=NULL*/)
	: CDialog(COsobaDlg::IDD, pParent) , mH(h),mJa(ja),mOtec(otec),mMatka(matka)
{
	//{{AFX_DATA_INIT(COsobaDlg)
	m_strID = _T("");
	m_strName = _T("");
	m_strSurname = _T("");
	m_intNaroz = 0;
	m_intUmrti = 0;
	m_inPohlavi = 0;
	m_intOtec = -1;
	m_intMatka = -1;
	//}}AFX_DATA_INIT
}


void COsobaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COsobaDlg)
	DDX_Control(pDX, IDC_MATKA, m_ctlMatka);
	DDX_Control(pDX, IDC_OTEC, m_ctlOtec);
	DDX_Text(pDX, IDC_ID, m_strID);
	DDX_Text(pDX, IDC_NAME, m_strName);
	DDX_Text(pDX, IDC_SURNAME, m_strSurname);
	DDX_Text(pDX, IDC_NAROZ, m_intNaroz);
	DDX_Text(pDX, IDC_NAROZ2, m_intUmrti);
	DDX_Radio(pDX, IDC_M, m_inPohlavi);
	DDX_CBIndex(pDX, IDC_OTEC, m_intOtec);
	DDX_CBIndex(pDX, IDC_MATKA, m_intMatka);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COsobaDlg, CDialog)
	//{{AFX_MSG_MAP(COsobaDlg)
	ON_BN_CLICKED(IDC_NOOTEC, OnNootec)
	ON_BN_CLICKED(IDC_NOMATKA, OnNomatka)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COsobaDlg message handlers

BOOL COsobaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	int hs=mH.GetSize();
	for (int i=0;i<hs;i++) {
		m_ctlOtec.AddString(mH[i]);
		m_ctlMatka.AddString(mH[i]);
	}

	m_ctlOtec.SetCurSel(mOtec);
	m_ctlMatka.SetCurSel(mMatka);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COsobaDlg::OnOK() 
{
	UpdateData(TRUE);

	if (m_intMatka == mJa) {
		MessageBox("Nemohu bt svoje matka!");

		return;
	}
	if (m_intOtec == mJa) {
		MessageBox("Nemohu bt svj otec!");

		return;
	}
	if (m_intOtec == m_intMatka && m_intOtec!=-1) {
		MessageBox("Nemohu mt matku a otce v jedn osob!");

		return;
	}
	
	CDialog::OnOK();
}

void COsobaDlg::OnNootec() 
{
	UpdateData(TRUE);
	m_intOtec=-1;
	UpdateData(FALSE);	
}

void COsobaDlg::OnNomatka() 
{
	UpdateData(TRUE);
	m_intMatka=-1;
	UpdateData(FALSE);	
}

void COsobaDlg::OnDel() 
{
	EndDialog(0x1234);	
}
