//Mistrovstvi CR v prog - mladez
//Cislo souteziciho : 29

// RodokmenView.cpp : implementation of the CRodokmenView class
//


#include "stdafx.h"
#include "Rodokmen.h"

#include "RodokmenDoc.h"
#include "RodokmenView.h"

#include "OsobaDlg.h"
#include "IdDlg.h"
#include "SeznamDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FRAMEX  60
#define FRAMEY  10

/////////////////////////////////////////////////////////////////////////////
// CRodokmenView

IMPLEMENT_DYNCREATE(CRodokmenView, CScrollView)

BEGIN_MESSAGE_MAP(CRodokmenView, CScrollView)
	//{{AFX_MSG_MAP(CRodokmenView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(IDM_RESTRUCTOR, OnRestructor)
	ON_COMMAND(IDM_GOTO, OnSeznamLidi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRodokmenView construction/destruction

CRodokmenView::CRodokmenView() : m_bInDrag(false)
{
	// TODO: add construction code here

}

CRodokmenView::~CRodokmenView()
{
}

BOOL CRodokmenView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CRodokmenView drawing

void CRodokmenView::OnDraw(CDC* pDC)
{
	CRodokmenDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	pDC->SetTextAlign(TA_CENTER);
	pDC->SetBkMode(TRANSPARENT);
	int rs=mRamecky.GetSize();

	for (int i=0;i<rs;i++) {
		int j=mRamecky[i].otec;
		if (j!=-1) {
			pDC->MoveTo(mRamecky[i].poloha.left+mRamecky[i].poloha.Width()/2,
			mRamecky[i].poloha.top+mRamecky[i].poloha.Height()/2);
			pDC->LineTo(mRamecky[j].poloha.left+mRamecky[j].poloha.Width()/2,
			mRamecky[j].poloha.top+mRamecky[j].poloha.Height()/2);

			int a=mRamecky[i].poloha.left+mRamecky[i].poloha.Width()/2;
			int b=mRamecky[j].poloha.left+mRamecky[j].poloha.Width()/2;
			int c=(a+b)/2;
			int x=(a+c)/2;

			a=mRamecky[i].poloha.top+mRamecky[i].poloha.Height()/2;
			b=mRamecky[j].poloha.top+mRamecky[j].poloha.Height()/2;
			c=(a+b)/2;
			int y=(a+c)/2;

//			pDC->Ellipse(x-5,y-5,x+5,y+5);
		}
		j=mRamecky[i].matka;
		if (j!=-1) {
			pDC->MoveTo(mRamecky[i].poloha.left+mRamecky[i].poloha.Width()/2,
			mRamecky[i].poloha.top+mRamecky[i].poloha.Height()/2);
			pDC->LineTo(mRamecky[j].poloha.left+mRamecky[j].poloha.Width()/2,
			mRamecky[j].poloha.top+mRamecky[j].poloha.Height()/2);
		}
	}

	for (i=0;i<rs;i++) {
		COLORREF col=(mRamecky[i].muz) ? RGB(25,25,255) : RGB(255,25,25);
		if (m_intSelected == i) col = RGB(255,255,25);

		if (mRamecky[i].poloha.right < 32767 &&
			mRamecky[i].poloha.bottom < 32767) {

			pDC->FillSolidRect(mRamecky[i].poloha,col);


			pDC->TextOut(mRamecky[i].poloha.left+mRamecky[i].poloha.Width()/2,
				mRamecky[i].poloha.top+2,
				mRamecky[i].jmeno);
		}
	}
}

void CRodokmenView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	m_bInDrag=false;

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 32767;
	sizeTotal.cy = 32767;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CRodokmenView diagnostics

#ifdef _DEBUG
void CRodokmenView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CRodokmenView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CRodokmenDoc* CRodokmenView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRodokmenDoc)));
	return (CRodokmenDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRodokmenView message handlers

CSize sizeTotal;

void CRodokmenView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (lHint == 0x1234) {
		CArray<CString,CString> &h=GetDocument()->GetIds();
		mRamecky.RemoveAll();
		m_bInDrag=false;

		m_intSelected=-1;

		int hs=h.GetSize();
		mRamecky.SetSize(hs,100);

		for (int i=0;i<hs;i++) {
			osoba o = GetDocument()->GetOsoba(h[i]);
			mRamecky[i].poloha=CRect(0,0,FRAMEX*2,FRAMEY*2);
			mRamecky[i].id=h[i];
			mRamecky[i].jmeno.Format("%s %s",o.jmeno,o.prijmeni);
			mRamecky[i].muz=o.pohlavi=="M";
			if (!o.otec.IsEmpty()) {
				for (int j=0;j<hs;j++)
					if (h[j]==o.otec)
						break;
				if (j<hs) {
					mRamecky[i].otec=j;
					mRamecky[j].deti.Add(i);
				}
			}
			else mRamecky[i].otec=-1;
			if (!o.matka.IsEmpty()) {
				for (int j=0;j<hs;j++)
					if (h[j]==o.matka)
						break;
				if (j<hs) {
					mRamecky[i].matka=j;
					mRamecky[j].deti.Add(i);
				}
			}
			else mRamecky[i].matka=-1;
		}

		OnRestructor();
		Invalidate();
	}
}


void CRodokmenView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	point.Offset(GetScrollPosition());
	if (m_bInDrag) return;
	int rs=mRamecky.GetSize();
	for (int i=0;i<rs;i++)
		if (mRamecky[i].poloha.PtInRect(point)) {
			last=point;

			CDC *dc=GetDC();
			OnPrepareDC(dc);

			dc->SetROP2(R2_NOT);
			dc->Rectangle(last.x-FRAMEX,last.y-FRAMEY,last.x+FRAMEX,last.y+FRAMEY);

			ReleaseDC(dc);

			m_bInDrag=true;
			draggedRect=i;
			m_intSelected = i;
			SetCapture();

			goto end;
		}
end:
	CScrollView::OnLButtonDown(nFlags, point);
}

void CRodokmenView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	point.Offset(GetScrollPosition());
	if (m_bInDrag) {
		CDC *dc=GetDC();
		OnPrepareDC(dc);

		dc->SetROP2(R2_NOT);
		dc->Rectangle(last.x-FRAMEX,last.y-FRAMEY,last.x+FRAMEX,last.y+FRAMEY);

		ReleaseDC(dc);
	
		mRamecky[draggedRect].poloha.left=point.x-FRAMEX;
		mRamecky[draggedRect].poloha.top=point.y-FRAMEY;
		mRamecky[draggedRect].poloha.right=point.x+FRAMEX;
		mRamecky[draggedRect].poloha.bottom=point.y+FRAMEY;

		Invalidate();

		m_bInDrag=false;
		ReleaseCapture();
	}
	
	CScrollView::OnLButtonUp(nFlags, point);
}

void CRodokmenView::OnMouseMove(UINT nFlags, CPoint point) 
{
	point.Offset(GetScrollPosition());
	if (m_bInDrag && last!=point) {
		CDC *dc=GetDC();
		OnPrepareDC(dc);

		dc->SetROP2(R2_NOT);
		dc->Rectangle(last.x-FRAMEX,last.y-FRAMEY,last.x+FRAMEX,last.y+FRAMEY);
		last=point;
		dc->Rectangle(last.x-FRAMEX,last.y-FRAMEY,last.x+FRAMEX,last.y+FRAMEY);

		ReleaseDC(dc);
	}
	
	CScrollView::OnMouseMove(nFlags, point);
}

//pridava ci edituje ci maze osoby
void CRodokmenView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	point.Offset(GetScrollPosition());
	int rs=mRamecky.GetSize();
	for (int i=0;i<rs;i++)
		if (mRamecky[i].poloha.PtInRect(point)) {

			osoba o = GetDocument()->GetOsoba(mRamecky[i].id);


			CArray<CString,CString> &h=GetDocument()->GetIds();
			int hs=h.GetSize(),ja,otec,matka;
			for (int j=0;j<hs;j++) {
				if (h[j]==o.id) ja=j;
				else if (h[j]==o.matka) matka=j;
				else if (h[j]==o.otec) otec=j;
			}


			COsobaDlg dlg(h,ja,otec,matka);

			dlg.m_strID=o.id;
			dlg.m_strName=o.jmeno;
			dlg.m_strSurname=o.prijmeni;
			dlg.m_inPohlavi=(o.pohlavi == "M") ? 0 : 1;
			dlg.m_intNaroz=o.narozeni;
			dlg.m_intUmrti=o.umrti;
			
			int ret=dlg.DoModal();
			if (ret==IDOK) {
				CString str;

				o.jmeno=dlg.m_strName;
				o.prijmeni=dlg.m_strSurname;
				o.pohlavi=(dlg.m_inPohlavi==0) ? "M" : "Z";
				o.narozeni=dlg.m_intNaroz;
				o.umrti=dlg.m_intUmrti;
				o.matka=(dlg.m_intMatka!=-1) ? h[dlg.m_intMatka] : "";
				o.otec=(dlg.m_intOtec!=-1) ? h[dlg.m_intOtec] : "";

				GetDocument()->SetOsoba(o.id,o);


				mRamecky[i].jmeno.Format("%s %s",o.jmeno,o.prijmeni);
				mRamecky[i].muz=dlg.m_inPohlavi==0;
				//je treba zmenit otce, sebrat staremu otci dite a dat ho novemu
				if (otec!=dlg.m_intOtec && dlg.m_intOtec!=-1) {
					int rs=mRamecky.GetSize();
					for (int k=0;k<rs;k++)
						if (mRamecky[k].id==h[dlg.m_intOtec])
							break;

					otec=mRamecky[i].otec;
					mRamecky[i].otec=k;

					if (otec!=-1) {
						int ds=mRamecky[otec].deti.GetSize();
						for (int l=0;l<ds;l++)
							if (mRamecky[otec].deti[l]==i) {
								mRamecky[otec].deti.RemoveAt(l);
								ds--;
							}
					}

					mRamecky[k].deti.Add(i);
				}
				else if (otec!=dlg.m_intOtec) {
					otec=mRamecky[i].otec;
					mRamecky[i].otec=-1;

					if (otec!=-1) {
						int ds=mRamecky[otec].deti.GetSize();
						for (int l=0;l<ds;l++)
							if (mRamecky[otec].deti[l]==i) {
								mRamecky[otec].deti.RemoveAt(l);
								ds--;
							}
					}
				}

				//to same s matkou
				if (matka!=dlg.m_intMatka && dlg.m_intMatka!=-1) {
					int rs=mRamecky.GetSize();
					for (int k=0;k<rs;k++)
						if (mRamecky[k].id==h[dlg.m_intMatka])
							break;

					matka=mRamecky[i].matka;
					mRamecky[i].matka=k;

					if (matka!=-1) {
						int ds=mRamecky[matka].deti.GetSize();
						for (int l=0;l<ds;l++)
							if (mRamecky[matka].deti[l]==i) {
								mRamecky[matka].deti.RemoveAt(l);
								ds--;
							}
					}

					mRamecky[k].deti.Add(i);
				}
				else if (matka!=dlg.m_intMatka) {
					matka=mRamecky[i].matka;
					mRamecky[i].matka=-1;

					if (matka!=-1) {
						int ds=mRamecky[matka].deti.GetSize();
						for (int l=0;l<ds;l++)
							if (mRamecky[matka].deti[l]==i) {
								mRamecky[matka].deti.RemoveAt(l);
								ds--;
							}
					}
				}
				Invalidate();
			}
			else if (ret==0x1234) {
				GetDocument()->DeleteOsoba(o.id);

				OnUpdate(NULL,0x1234,0);
			}

			return;
		}

	//insert new one
	CIdDlg dlgid;

	if (dlgid.DoModal()==IDOK) {
		int ok=1;

		CArray<CString,CString> &h=GetDocument()->GetIds();
		int hs=h.GetSize();

		for (i=0;i<hs;i++)
			if (dlgid.m_strId == h[i])
				ok=0;


		if (!ok) {
			MessageBox("Toto id ji existuje!");
		}
		else {
			COsobaDlg dlg(h,-2,-1,-1);
			dlg.m_strID=dlgid.m_strId;
			if (dlg.DoModal()==IDOK) {
				CString str;
				osoba o;

				o.id=dlg.m_strID;
				o.jmeno=dlg.m_strName;
				o.prijmeni=dlg.m_strSurname;
				o.pohlavi=(dlg.m_inPohlavi==0) ? "M" : "Z";
				o.narozeni=dlg.m_intNaroz;
				o.umrti=dlg.m_intUmrti;
				o.matka=(dlg.m_intMatka!=-1) ? h[dlg.m_intMatka] : "";
				o.otec=(dlg.m_intOtec!=-1) ? h[dlg.m_intOtec] : "";

				GetDocument()->SetOsoba(o.id,o);

				mRamecky.SetSize(mRamecky.GetSize()+1,100);
				mRamecky[i].poloha.left=point.x-FRAMEX;
				mRamecky[i].poloha.top=point.y-FRAMEY;
				mRamecky[i].poloha.right=point.x+FRAMEX;
				mRamecky[i].poloha.bottom=point.y+FRAMEY;
				mRamecky[i].id=dlg.m_strID;
				mRamecky[i].muz=dlg.m_inPohlavi==0;

				mRamecky[i].jmeno.Format("%s %s",o.jmeno,o.prijmeni);

				if (dlg.m_intMatka!=-1) {
					for (int k=0;k<hs;k++)
						if (mRamecky[k].id == h[dlg.m_intMatka])
							break;
	
					mRamecky[i].matka=k;
					mRamecky[k].deti.Add(i);
				}
				else mRamecky[i].matka=-1;

				if (dlg.m_intOtec!=-1) {
					for (int k=0;k<hs;k++)
						if (mRamecky[k].id == h[dlg.m_intOtec])
							break;
	
					mRamecky[i].otec=k;
					mRamecky[k].deti.Add(i);
				}
				else mRamecky[i].otec=-1;

				Invalidate();
			}
		}
	}


	CScrollView::OnRButtonDown(nFlags, point);
}

CArray<int,int> sloupce;

void CRodokmenView::Projdi(int i,int l)
{
	if (mRamecky[i].done) return;
	mRamecky[i].done=true;

	if (l >= sloupce.GetSize())
		sloupce.Add(0);

	mRamecky[i].poloha.left =  sloupce[l] * (FRAMEX * 2 + 20) + 5;
	mRamecky[i].poloha.right = sloupce[l] * (FRAMEX * 2 + 20) + 5 + FRAMEX * 2;
	mRamecky[i].poloha.top =  l * (FRAMEY * 2 + 20) + 5;
	mRamecky[i].poloha.bottom = l * (FRAMEY * 2 + 20) + 5 + FRAMEY * 2;

	sloupce[l]++;

	int ds=mRamecky[i].deti.GetSize();
	for (int j=0;j<ds;j++)
		if (!mRamecky[mRamecky[i].deti[j]].done)
			Projdi(mRamecky[i].deti[j],l+1);
}

void CRodokmenView::OnRestructor() 
{
	int rs=mRamecky.GetSize();
	for (int i=0;i<rs;i++)
		mRamecky[i].done=false;
	sloupce.RemoveAll();

	for (i=0;i<rs;i++)
		if (mRamecky[i].otec == -1 && mRamecky[i].matka == -1 && !mRamecky[i].done) {
			Projdi(i,0);
		}

	int max=1;
	int hs=sloupce.GetSize();
	for (i=0;i<hs;i++)
		if (sloupce[i]>max) max=sloupce[i];

	Invalidate();
}

void CRodokmenView::OnSeznamLidi() 
{
	CSeznamDlg dlg(mRamecky);

	dlg.DoModal();
}
