//Mistrovstvi CR v prog - mladez
//Cislo souteziciho : 29

// RodokmenDoc.cpp : implementation of the CRodokmenDoc class
//

#include "stdafx.h"
#include "Rodokmen.h"

#include "RodokmenDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRodokmenDoc

IMPLEMENT_DYNCREATE(CRodokmenDoc, CDocument)

BEGIN_MESSAGE_MAP(CRodokmenDoc, CDocument)
	//{{AFX_MSG_MAP(CRodokmenDoc)
	ON_COMMAND(IDM_MERGE, OnMerge)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRodokmenDoc construction/destruction

CRodokmenDoc::CRodokmenDoc() : m_bFuckLoading(false)
{
	// TODO: add one-time construction code here

}

CRodokmenDoc::~CRodokmenDoc()
{
}

BOOL CRodokmenDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	RemoveAll();

	UpdateAllViews(NULL,0x1234);

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CRodokmenDoc serialization

CString GetCommand(CArchive& ar,CString comm)
{
	CString fcomm=comm + '/';
	CString str,res;
	unsigned char c;
l1:
	while (ar >> c,c!='<') ;
	while (ar >> c,c!='>') str+=c;

	str.TrimLeft();
	str.TrimRight();
	if (str==fcomm) return res;
	else if(str==comm) {
		comm='/' + comm;
l2:
		str.Empty();
		while (ar >> c,c!='<') res+=c;
		while (ar >> c,c!='>') str+=c;

		str.TrimLeft();
		str.TrimRight();

		if (str!=comm) goto l2;
		return res;
	}
	goto l1;
}

CString FormatCommand(const char *command,CString &value)
{
	CString ret;
	if (value.IsEmpty())
		ret.Format("      <%s/>\n",command);
	else
		ret.Format("      <%s>%s</%s>\n",command,value,command);

	return ret;
}

void CRodokmenDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar.WriteString("<rodokmen>\n");

		POSITION pos=mRodiny.GetStartPosition();
		while (pos) {
			CString key;
			CString str;
			osoba *o;
			mRodiny.GetNextAssoc(pos,key,((void *&)o));
			str+="   <osoba>\n";
			str+=FormatCommand("id",o->id);
			str+=FormatCommand("jmeno",o->jmeno);
			str+=FormatCommand("prijmeni",o->prijmeni);
			str+=FormatCommand("pohlavi",o->pohlavi);
			if (o->narozeni==-1) 
				key.Empty();
			else
				key.Format("%d",o->narozeni);
			str+=FormatCommand("narozeni",key);
			if (o->umrti==-1) 
				key.Empty();
			else
				key.Format("%d",o->umrti);
			str+=FormatCommand("umrti",key);
			str+=FormatCommand("matka",o->matka);
			str+=FormatCommand("otec",o->otec);
			str+="   </osoba>\n";

			ar.WriteString(str);
		}
		ar.WriteString("</rodokmen>\n");
	}
	else
	{
		if (!m_bFuckLoading) //pokud je promenna nastavena, mergeuj
			RemoveAll();

		unsigned char c;
		CString str;
start:
		while (ar >> c,c!='<') ;
		while (ar >> c,c!='>') str+=c;

		if (str!="rodokmen") goto start;
next_os:
		str.Empty();
		while (ar >> c,c!='<') ;
		while (ar >> c,c!='>') str+=c;
		if (str=="/rodokmen") goto end;
		if (str=="osoba") {
			osoba *o=new osoba;
			o->id=GetCommand(ar,"id");
			o->jmeno=GetCommand(ar,"jmeno");
			o->prijmeni=GetCommand(ar,"prijmeni");
			o->pohlavi=GetCommand(ar,"pohlavi");
			str=GetCommand(ar,"narozeni");
			o->narozeni=(str.IsEmpty()) ? -1 : atoi(str);
			str=GetCommand(ar,"umrti");
			o->umrti=(str.IsEmpty()) ? -1 : atoi(str);
			o->matka=GetCommand(ar,"matka");
			o->otec=GetCommand(ar,"otec");

			mRodiny[o->id]=o;
		}
		goto next_os;

	}
end:
	UpdateAllViews(NULL,0x1234);
}

/////////////////////////////////////////////////////////////////////////////
// CRodokmenDoc diagnostics

#ifdef _DEBUG
void CRodokmenDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CRodokmenDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRodokmenDoc commands

void CRodokmenDoc::RemoveAll()
{
	POSITION pos=mRodiny.GetStartPosition();
	while (pos) {
		CString key;
		osoba *o;
		mRodiny.GetNextAssoc(pos,key,((void *&)o));

		delete o;
	}
	mRodiny.RemoveAll();
	mRodiny.InitHashTable(16383);
}

void CRodokmenDoc::OnMerge() 
{
	CFileDialog	fd(TRUE,"xml",0,OFN_HIDEREADONLY,"All files|*.*|Xml files|*.xml||");
	if (fd.DoModal()==IDOK) {
		CFile f;
		if( !f.Open( fd.GetPathName(), CFile::modeRead ) ) {
			MessageBox(NULL,"Can't open selected file!","ERROR",MB_OK);
			return;
		}
	
		CArchive ar( &f, CArchive::load);
		m_bFuckLoading=true;
		Serialize(ar);
		m_bFuckLoading=false;
	}
}

CArray<CString,CString>& CRodokmenDoc::GetIds()
{
	static CArray<CString,CString> h;
	h.RemoveAll();

	POSITION pos=mRodiny.GetStartPosition();
	while (pos) {
		CString key;
		osoba *o;
		mRodiny.GetNextAssoc(pos,key,((void *&)o));
		h.Add(key);
	}
	return h;
}

osoba CRodokmenDoc::GetOsoba(CString id)
{
	osoba *o;
	if (!mRodiny.Lookup(id,((void *&)o))) return osoba();
	return *o;
}

void CRodokmenDoc::SetOsoba(CString id, osoba &o)
{
	osoba *p;
	if (mRodiny.Lookup(id,((void *&)p))) {
		delete p;
		mRodiny.RemoveKey(id);
	}
	p=new osoba;
	*p=o;
	mRodiny[id]=p;
}

bool CRodokmenDoc::IsOsoba(CString id)
{
	osoba *o;
	return mRodiny.Lookup(id,((void *&)o))!=0;	
}

void CRodokmenDoc::DeleteOsoba(CString id)
{
	osoba *p;
	if (mRodiny.Lookup(id,((void *&)p))) {
		delete p;
		mRodiny.RemoveKey(id);
	}
}
